#pragma once

using namespace System;
using namespace System::Collections;
using namespace System::Text;
using namespace System::Runtime::InteropServices;
using namespace System::Windows::Forms;

//#using <mscorlib.dll>

namespace wsq_demo
{
	private ref class WSQImageLibraryNativeMethods
	{

	public:
		WSQImageLibraryNativeMethods()
		{
		}


		static IntPtr bitmap_ptr = IntPtr::Zero;



	private:
		[DllImport("WSQ_library64.dll", CharSet = CharSet::Unicode)]
		static void RegisterWSQ();
	public:
		void pRegisterWSQ()
		{
			try
			{
				RegisterWSQ();
			}
			catch (Exception ^ex)
			{
				MessageBox::Show(ex->Message, "RegisterWSQ Exception", MessageBoxButtons::OK, MessageBoxIcon::Error);
			}
		}

	private:
		[DllImport("WSQ_library64.dll", CharSet = CharSet::Unicode)]
		static IntPtr CreateBMPFromFile(array<System::Byte> ^lpszFileName);
	public:
		IntPtr pCreateBMPFromFile(System::String ^FileName)
		{

			if (FileName == nullptr)
				throw gcnew ArgumentNullException("FileName should be not null");
			if (FileName->Length == 0)
				throw gcnew ArgumentException("Incorrect file name");
			try
			{
				UTF8Encoding ^utf8 = gcnew UTF8Encoding;
				//return CreateBMPFromFile(utf8->GetBytes(FileName));
				bitmap_ptr = CreateBMPFromFile(utf8->GetBytes(FileName));
                return bitmap_ptr;

			}
			catch (Exception ^ex)
			{
				MessageBox::Show(ex->Message, "CreateBMPFromFile Exception", MessageBoxButtons::OK, MessageBoxIcon::Error);
			}
			return IntPtr::Zero;
		}

	private:
		[DllImport("WSQ_library64.dll", CharSet = CharSet::Unicode)]
		static Int64 SaveBMPToFile(IntPtr hBitmap, array<System::Byte> ^filename, [MarshalAs(UnmanagedType::I8)] Int64 filetype);
	public:
		Int64 pSaveBMPToFile(IntPtr Bitmap, System::String ^FileName, Int64 FileType)
		{
			Int64 retVal = -1;
			if ((Bitmap == (IntPtr)nullptr)||(FileName == nullptr))
				throw gcnew ArgumentNullException("Bitmap and FileName should be not null");
			if (FileName->Length == 0)
				throw gcnew ArgumentException("Incorrect file name");
			try
			{
				UTF8Encoding ^utf8 = gcnew UTF8Encoding;
				retVal = SaveBMPToFile(Bitmap, utf8->GetBytes(FileName), FileType);
			}
			catch (Exception ^ex)
			{
				MessageBox::Show(ex->Message, "SaveBMPToFile Exception", MessageBoxButtons::OK, MessageBoxIcon::Error);
			}
			return retVal;
		}


	private:
		[DllImport("WSQ_library64.dll", CharSet = CharSet::Unicode)]
		static IntPtr CreateBMPFromWSQByteArray([In] array<System::Byte> ^input_wsq_compressed_byte_array, 
			[In, MarshalAs(UnmanagedType::I8)] Int64 input_wsq_compressed_byte_array_length);
	public:
		IntPtr pCreateBMPFromWSQByteArray([In] array<System::Byte> ^input_wsq_compressed_byte_array, [In] Int64 input_wsq_compressed_byte_array_length)
		{

			try
			{
				IntPtr bitmap_local(CreateBMPFromWSQByteArray(input_wsq_compressed_byte_array, input_wsq_compressed_byte_array_length));
				return bitmap_local;
			}
			catch (Exception ^ex)
			{
				MessageBox::Show(ex->Message, "CreateBMPFromWSQByteArray Exception", MessageBoxButtons::OK, MessageBoxIcon::Error);
			}
			return IntPtr::Zero;
		}


	private:
		[DllImport("WSQ_library64.dll", CharSet = CharSet::Unicode)]
		static Int64 SaveWSQByteArrayToImageFile([In] array<System::Byte> ^input_wsq_compressed_byte_array, [In, MarshalAs(UnmanagedType::I8)] Int64 input_wsq_compressed_byte_array_length, array<System::Byte> ^filename, [MarshalAs(UnmanagedType::I8)] Int64 filetype);
	public:
		Int64 pSaveWSQByteArrayToImageFile([In] array<System::Byte> ^input_wsq_compressed_byte_array, [In] Int64 input_wsq_compressed_byte_array_length, System::String ^FileName, Int64 FileType)
		{
			Int64 retVal = -1;
			if (FileName == nullptr)
									 throw gcnew ArgumentNullException("FileName should be not null");
			if (FileName->Length == 0)
				throw gcnew ArgumentException("Incorrect file name");

			try
			{
				UTF8Encoding ^utf8 = gcnew UTF8Encoding;
				retVal = SaveWSQByteArrayToImageFile(input_wsq_compressed_byte_array, input_wsq_compressed_byte_array_length, utf8->GetBytes(FileName), FileType);
			}
			catch (Exception ^ex)
			{
				MessageBox::Show(ex->Message, "SaveWSQByteArrayToImageFile Exception", MessageBoxButtons::OK, MessageBoxIcon::Error);
			}
			return retVal;
		}





	private:
		[DllImport("WSQ_library64.dll", CharSet = CharSet::Unicode)]
		static void SetShowFilePropertiesDialog([MarshalAs(UnmanagedType::I8)] Int64 file_properties_dialog);
	public:
		void pSetShowFilePropertiesDialog(Int64 file_properties_dialog)
		{
			try
			{
				SetShowFilePropertiesDialog(file_properties_dialog);
			}
			catch (Exception ^ex)
			{
				MessageBox::Show(ex->Message, "SetShowFilePropertiesDialog Exception", MessageBoxButtons::OK, MessageBoxIcon::Error);
			}
		}

	private:
		[DllImport("WSQ_library64.dll", CharSet = CharSet::Unicode)]
		static void ShowFileConverter();
	public:
		void pShowFileConverter()
		{
			try
			{
				ShowFileConverter();
			}
			catch (Exception ^ex)
			{
				MessageBox::Show(ex->Message, "ShowFileConverter Exception", MessageBoxButtons::OK, MessageBoxIcon::Error);
			}
		}

		
		
		
	private:
		[DllImport("WSQ_library64.dll", CharSet = CharSet::Unicode)]
		static Int64 WSQ_decode_stream([In] array<System::Byte> ^input_wsq_compressed_byte_array, [In, MarshalAs(UnmanagedType::I8)] Int64 input_wsq_compressed_byte_array_length, 
			[System::Runtime::InteropServices::Out] unsigned char** output_decompressed_byte_array, 
			[System::Runtime::InteropServices::Out, MarshalAs(UnmanagedType::I8)] Int64 %width, 
			[System::Runtime::InteropServices::Out, MarshalAs(UnmanagedType::I8)] Int64 %height, 
			[System::Runtime::InteropServices::Out, MarshalAs(UnmanagedType::I8)] Int64 %ppi, 
			[System::Runtime::InteropServices::Out] char** comment_text);
	public:
		Int64 pWSQ_decode_stream([In] array<System::Byte> ^input_wsq_compressed_byte_array, [In] Int64 input_wsq_compressed_byte_array_length, [System::Runtime::InteropServices::Out] array<System::Byte> ^%output_decompressed_byte_array, [System::Runtime::InteropServices::Out] Int64 %width, [System::Runtime::InteropServices::Out] Int64 %height, [System::Runtime::InteropServices::Out] Int64 %ppi, [System::Runtime::InteropServices::Out] System::String ^%comment_text)
		{
			Int64 retVal = -1;
			output_decompressed_byte_array = gcnew array<System::Byte>(1);
			width = height = ppi = 0;
			comment_text = "";
			try
			{
				static unsigned char* decompressed_buffer;
				static char* comment;

				WSQ_decode_stream(input_wsq_compressed_byte_array, input_wsq_compressed_byte_array_length, 
					&decompressed_buffer, width, height, ppi, &comment);

				IntPtr wsq_decompressed_byte_array_ptr(decompressed_buffer);
				IntPtr out_comment_text_ptr(comment);

				comment_text = Marshal::PtrToStringAnsi(out_comment_text_ptr);
				Int64 output_decompressed_byte_array_length = width * height;
				output_decompressed_byte_array = gcnew array<System::Byte>((Int32)output_decompressed_byte_array_length);
				Marshal::Copy(wsq_decompressed_byte_array_ptr, output_decompressed_byte_array, 0, (Int32)output_decompressed_byte_array_length);
			}
			catch (Exception ^ex)
			{
				MessageBox::Show(ex->Message, "WSQ_decode_stream Exception", MessageBoxButtons::OK, MessageBoxIcon::Error);
			}
			return retVal;
		}

		
		

	private:
		[DllImport("WSQ_library64.dll", CharSet = CharSet::Unicode)]
		static Int64 WSQ_encode_stream([In] array<System::Byte> ^input_wsq_decompressed_byte_array, 
			[In, MarshalAs(UnmanagedType::I8)] Int64 width, 
			[In, MarshalAs(UnmanagedType::I8)] Int64 height, 
			[In, MarshalAs(UnmanagedType::R8)] double bitrate, 
			[In, MarshalAs(UnmanagedType::I8)] Int64 ppi, 
			[In] array<System::Byte> ^commentText, 
			[System::Runtime::InteropServices::Out] unsigned char** output_compressed_byte_array, 
			[System::Runtime::InteropServices::Out] Int64 %output_compressed_byte_array_length);			
	public:
		Int64 pWSQ_encode_stream(array<System::Byte> ^input_wsq_decompressed_byte_array, Int64 width, Int64 height, 
			double bitrate, Int64 ppi, System::String ^commentText, 
			[System::Runtime::InteropServices::Out] array<System::Byte> ^%output_compressed_byte_array, 
			[System::Runtime::InteropServices::Out] Int64 %output_compressed_byte_array_length)
		{
			Int64 retVal = -1;
			output_compressed_byte_array = nullptr;
			output_compressed_byte_array_length = 0;
			try
			{
				static unsigned char* compressed_buffer;
				UTF8Encoding ^utf8 = gcnew UTF8Encoding;


				WSQ_encode_stream(input_wsq_decompressed_byte_array, width, height, bitrate, ppi, 
					utf8->GetBytes(commentText), &compressed_buffer, output_compressed_byte_array_length);

				if (output_compressed_byte_array_length == 0)
					throw gcnew ArgumentException("output_compressed_byte_array_length == 0");
				output_compressed_byte_array = gcnew array<System::Byte>((Int32)output_compressed_byte_array_length);
				IntPtr wsq_compressed_byte_array_ptr( compressed_buffer );

				Marshal::Copy(wsq_compressed_byte_array_ptr, output_compressed_byte_array, 0, (Int32)output_compressed_byte_array_length);
			}
			catch (Exception ^ex)
			{
				MessageBox::Show(ex->Message, "WSQ_encode_stream Exception", MessageBoxButtons::OK, MessageBoxIcon::Error);
			}
			return retVal;
		}






	private:
		[DllImport("WSQ_library64.dll", CharSet = CharSet::Unicode)]
		static IntPtr ConvertHBITMAPtoGrayScale256(IntPtr hBitmap);
	public:
		IntPtr pConvertHBITMAPtoGrayScale256(IntPtr Bitmap)
		{
			try
			{
				return ConvertHBITMAPtoGrayScale256(Bitmap);
			}
			catch (Exception ^ex)
			{
				MessageBox::Show(ex->Message, "ConvertHBITMAPtoGrayScale256 Exception", MessageBoxButtons::OK, MessageBoxIcon::Error);
			}
			return IntPtr::Zero;
		}


	private:
		[DllImport("WSQ_library64.dll", CharSet = CharSet::Unicode)]
		static Int64 SaveHBITMAPtoFileAsGrayScale256BMP(IntPtr hBitmap, array<System::Byte> ^filename);
	public:
		Int64 pSaveHBITMAPtoFileAsGrayScale256BMP(IntPtr Bitmap, System::String ^FileName)
		{
			Int64 retVal = -1;
			if ((Bitmap == (IntPtr)nullptr)||(FileName == nullptr))
				throw gcnew ArgumentNullException("Bitmap and FileName should be not null");
			if (FileName->Length == 0)
				throw gcnew ArgumentException("Incorrect file name");
			try
			{
				UTF8Encoding ^utf8 = gcnew UTF8Encoding;
				retVal = SaveHBITMAPtoFileAsGrayScale256BMP(Bitmap, utf8->GetBytes(FileName));
			}
			catch (Exception ^ex)
			{
				MessageBox::Show(ex->Message, "SaveHBITMAPtoFileAsGrayScale256BMP Exception", MessageBoxButtons::OK, MessageBoxIcon::Error);
			}
			return retVal;
		}
	};
}